<?

use LabBase\Model\Brand;
use LabBase\Model\BrandPost;
use LabBase\Model\User;

$this->headStyle()->appendStyle(
    <<<CSS

.commentsHeader {
    font-size: 125%;
    color: #666;
    padding: 0 5px 4px 5px;
    border-bottom: 1px solid #cacaca;
    margin-bottom: 10px;
}

.commentsHeader a {
    font-size: 90%;
    padding: 0 6px;
}

.commentsHeader a.active {
    font-weight: bolder;
}

#commentsContainer {
    padding: 4px 10px;
}

.comment {
    margin-top: 15px;
    margin-bottom: 20px;
    color: #555;
}
.comment:first-child {
    margin-top: 0;
}

.comment.notPublic *:not(a)  {
    color: #aaa;
}

.comment header {
    display: table-cell;
    vertical-align: middle;
    height: 32px;
    margin-bottom: 5px;
    font-size: 115%;
    width: 100%;
}

.comment .menu {
    display: inline-block;
    vertical-align: top;
    line-height: 32px;
    float: right;
    margin: 0 10px 10px 10px;
}

.comment header img {
    height: 32px;
    max-width: 128px;
    display: inline-block;
    vertical-align: middle;
    border: 1px solid #fafafa;
    margin-right: 4px;
}

.comment header small {
    font-size: 90%;
}

.comment p {
    margin: 2px 0;
    line-height: 125%;
}




CSS
);
?>

<div class="feedNode">
    <div class="feedContent">
        <div class="commentsHeader">
            Comments
            <span class="float-right">
                <a <? if($this->commentsType == 'latest') echo 'class="active" '; ?>
                    href="<?= $this->url('root/manageComments', ['brandId' => ''.$this->brandId, 'commentsType' => 'latest']); ?>">Latest</a>
                <a <? if($this->commentsType == 'rejected') echo 'class="active" '; ?>
                    href="<?= $this->url('root/manageComments', ['brandId' => ''.$this->brandId, 'commentsType' => 'rejected']); ?>">Rejected</a>
                <a <? if($this->commentsType == 'approved') echo 'class="active" '; ?>
                    href="<?= $this->url('root/manageComments', ['brandId' => ''.$this->brandId, 'commentsType' => 'approved']); ?>">Approved</a>
            </span>
        </div>


        <script>
            var commentMenuAntiDoubleclick = 0;
            var commentMenuAntiDoubleclickObject = 0;
            function commentMenuClick(el) {
                if(commentMenuAntiDoubleclickObject == el && commentMenuAntiDoubleclick > new Date().getTime()) {
                    return false;
                }
                commentMenuAntiDoubleclickObject = el;
                commentMenuAntiDoubleclick = new Date().getTime() + 800;

                var $this = $(el);
                var url = $this.attr('href');
                ajaxSubmit(url, {}, function(data) {
                    if(!data.status || data.status != "ok") {
                        console.log("commentMenuClick error: ", data);
                        labAlert(data.status ? data.status : "An error has occurred, please try again.");
                    }else{
                        updateComments(); // todo refresh given comment
                    }
                });

                return false;
            }

            var $commentTextarea = $('#commentTextarea');
            var $commentControls = $('#commentControls');
            var commentClicked = false;
            var systemMessageInComment = false;
            function showSystemMessageInCommentBox(text) {
                $commentControls.animate({height: '0'}, 400, function() {
                    $commentControls.hide();
                    commentClicked = false;
                });
                $commentTextarea.css({backgroundColor: '#e9f7e8', color: '#555'});
                $commentTextarea.val(text);
                systemMessageInComment = true;
            }
            $commentTextarea.click(function() {
                if(!commentClicked) {
                    commentClicked = true;

                    if(systemMessageInComment) {
                        $commentTextarea.css({backgroundColor: 'white', color: '#111'});
                        $commentTextarea.val('');
                    }

                    // If the user did not change the textarea size (its height is close 40 => assume not resized)
                    if(Math.abs(40 - $commentTextarea.outerHeight()) < 5) {
                        $commentTextarea.animate({height: '65px'}, 400);
                    }
                    $commentControls.show();
                    $commentControls.animate({height: '35px'}, 400);
                }
            });

            $(function () {
                window.setTimeout(function () {
                    updateComments();
                }, 100);
            });
            var loadedComments = [];
            var lastCommentUpdate = new Date().getTime();
            function updateComments(lowPriority) {
                if(lowPriority) {
                    if(lastCommentUpdate + 1000 * 3 > new Date().getTime())
                        return;
                }
                lastCommentUpdate = new Date().getTime();

                var params = {};

                if(loadedComments.length > 0) {
                    var firstId = loadedComments[0].id;
                    var lastId = loadedComments[loadedComments.length - 1].id;
                    if(lastId > firstId) {
                        var tmp = lastId;
                        lastId = firstId;
                        firstId = tmp;
                    }
                    params = {
                        firstId: firstId,
                        lastId: lastId
                    }
                }

                $.post("<?= $this->url("root/brandGetAllComments", ["brandId" => $this->brandId, "commentsType" => $this->commentsType]) ?>", params, function(data) {
                    if(data.status != "ok") {
                        console.log("updateComments error: " + data.status);
                    }else{
                        console.log(data);
                        loadedComments = data.comments;

                        loadedComments.sort(function(a, b) {
                            return b.id - a.id;
                        });

                        displayComments(loadedComments);
                    }
                });
            }


            function displayComments(comments) {
                var $commentsContainer = $("#commentsContainer");
                console.log($commentsContainer);
                $commentsContainer.empty();

                if(comments.length == 0) {
                    $commentsContainer[0].innerHTML = "<center>No comments found</center>";

                }
                for(var k in comments) {
                    var c = comments[k];

                    var name = c.name;
                    if(c.nameUrl && c.nameUrl.length > 0) {
                        name = '<a href="' + c.nameUrl + '">' + name + '</a>';
                    }
                    var content = '<p>' + c.text.replace('\n\n', '\n').replace('\n', '</p><p>') + '</p>';
                    var menu = '';
                    var time = formatAgoTime(c.datePosted);
                    var classes = 'comment';
                    if(!c.public) classes += ' notPublic';


                    var manageURL = "<?= $this->url('root/brandPostManageComment', ['commentId' => 'COMMENTID', 'action' => 'ACTION']) ?>";
                    var fURL = function (id, action) {
                        return manageURL.replace('COMMENTID', id).replace('ACTION', action);
                    };

                    if(!c.public) {
                        menu += '<a onclick="return commentMenuClick(this);" href="' + fURL(c.id, 'approveComment') + '">Approve</a> - ';
                        menu += '<a onclick="return commentMenuClick(this);" href="' + fURL(c.id, 'rejectComment') + '">Reject</a> ';
                    }else {
                        menu += '<a onclick="return commentMenuClick(this);" href="' + fURL(c.id, 'rejectComment') + '">Remove comment</a> ';
                    }


                    var template =
                        '<div class="'+classes+'"><div class="inline-block"><header>' +
                        name + '<small> - ' + time + '</small></header></div>' +
                        '<div class="menu">' + menu + '</div><div>' + content + '</div></div>';

                    $commentsContainer.append($.parseHTML(template));

                }
            }
        </script>

        <div id="commentsContainer">
            <br />
            Loading comments...
        </div>
    </div>
</div>

<div style="height:50px;"></div>
